! iso_fortran_env.f90
!
! Standard intrinsic module ISO_FORTRAN_ENV
!
! Copyright 2004-2011 The Numerical Algorithms Group Ltd., Oxford, U.K.
!
! Release 5.1: 1.3, 06/08/30
!
! Release 5.2: iso_fortran_env.f90 1 2009-12-02 02:54:28Z Malcolm Cohen
!
! Release 5.3: $Id: iso_fortran_env.f90 1592 2011-09-21 04:24:45Z Malcolm Cohen $
!
Module,Intrinsic :: Iso_Fortran_Env
  Intrinsic :: Bit_Size,Dim,Kind,Merge,Selected_Char_Kind,Selected_Int_Kind, &
               Selected_Real_Kind
  Private :: Bit_Size,Dim,Kind,Merge,Selected_Char_Kind,Selected_Int_Kind, &
             Selected_Real_Kind
  !
  ! Storage unit sizes in bits
  !
  Integer,Parameter :: character_storage_size = 8
  Integer,Parameter :: numeric_storage_size = Bit_Size(0)
  !
  ! Standard i/o unit numbers
  !
  Integer,Parameter :: error_unit = 0
  Integer,Parameter :: input_unit = 5
  Integer,Parameter :: output_unit = 6
  !
  ! The unit of measurement for RECL= in OPEN/INQUIRE (in bits).
  !
  Integer,Parameter :: file_storage_size = 8
  !
  ! IOSTAT return values (a subset of those in f90_iostat, and iostat_eof
  !                       is called iostat_end).
  !
  Integer,Parameter :: iostat_end = -1
  Integer,Parameter :: iostat_eor = -2
  Integer,Parameter :: iostat_inquire_internal_unit = 242
  !
  ! Fortran 2008: Constants for specific kinds.
  !
  Integer,Parameter :: int8 = Selected_Int_Kind(2)
  Integer,Parameter :: int16 = Selected_Int_Kind(4)
  Integer,Parameter :: int32 = Selected_Int_Kind(9)
  Integer,Parameter :: int64 = Selected_Int_Kind(18)
  Integer,Parameter :: real32 = Selected_Real_Kind(6)
  Integer,Parameter :: real64 = Selected_Real_Kind(15)
  Integer,Private,Parameter :: trueq = Dim(Selected_Real_Kind(33,4900),0)
  Integer,Private,Parameter :: ddq = Dim(Selected_Real_Kind(31,291),0)
  Integer,Private,Parameter :: real64x2 = Merge(tsource=ddq,fsource=-1, &
                                                mask=(ddq>0 .And. ddq/=trueq))
  ! Prefer IEEE-compliant 128-bit-real over double-double if both available.
  Integer,Parameter :: real128 = Merge(tsource=trueq,fsource=real64x2, &
                                       mask=trueq>0)
  !
  ! Fortran 2008: Lists of supported kinds.
  !
  Integer,Parameter :: character_kinds(4) = [ Kind('A'), &
                                              Selected_Char_Kind('SHIFT_JIS'), &
                                              Selected_Char_Kind('UCS_2'), &
                                              Selected_Char_Kind('ISO_10646') ]
  Integer,Parameter :: integer_kinds(4) = [ int8,int16,int32,int64 ]
  Integer,Parameter :: logical_kinds(4) = integer_kinds
  Integer,Parameter :: real_kinds(3) = [ real32,real64,real128 ]
End Module
